--- /home/howard/projects/jboss-docker/amq6/repo/b_openshift_img/a/image.yaml
+++ /home/howard/projects/jboss-docker/amq6/repo/b_openshift_img/b/image.yaml
@@ -5,6 +5,8 @@
 version: "1.4"
 from: "jboss-amq-6/amq63:latest"
 labels:
+    - name: "com.redhat.component"
+      value: "jboss-amq-6-amq63-openshift-container"
     - name: "io.k8s.description"
       value: "A reliable messaging platform that supports standard messaging paradigms for a real-time enterprise."
     - name: "io.k8s.display-name"
@@ -14,112 +16,51 @@
     - name: "io.openshift.s2i.scripts-url"
       value: "image:///usr/local/s2i"
 envs:
-    - name: "AB_JOLOKIA_PASSWORD_RANDOM"
-      value: "true"
-    - name: AB_JOLOKIA_AUTH_OPENSHIFT
-      value: "true"
-    - name: AB_JOLOKIA_HTTPS
-      value: "true"
+    - name: AMQ_USERNAME
+      example: username
+      description: Username for AMQ authentication and authentication
+    - name: AMQ_PASSWORD
+      example: password
+      description: Password corresponding to AMQ_USERNAME
+    - name: AMQ_DNAME
+      example: CN=localhost, OU=broker, O=Unknown, L=Unknown, ST=Unknown, C=Unknown
+      description: SSL certificate distinguished name corresponding to AMQ_USERNAME
     - name: AMQ_SPLIT
       example: true
       description: "Allow multiple instances to share the same Persistent Volume.  If set to true each instance will use a separate area within the Persistent Volume as its data directory.  Default is unset."
     - name: AMQ_LOCK_TIMEOUT
       example: 30
       description: "If allowing multiple instances to share the same Persistent Volume then wait for this timeout period (seconds) to see if an existing server will terminate before moving to the next instance.  Default is 30 seconds."
+    - name: "AMQ_STORAGE_USAGE_LIMIT"
+      example: "10 gb"
+      description: "Sets the store disk limit usage in activemq.xml. If the value set is greater than the disk size, it will be resized to the available disk space."
     - name: "AMQ_QUEUE_MEMORY_LIMIT"
       example: "2mb"
       description: "Sets the queue memory limit in activemq.xml"
-    - name: "JAVA_OPTS_APPEND"
-      example: "-Dactivemq.foo=bar"
-      description: "Server startup options."
-    - name: AB_JOLOKIA_OFF
-      description: If set disables activation of Joloka (i.e. echos an empty value). By default, Jolokia is enabled.
-      example: "true"
-    - name: AB_JOLOKIA_CONFIG
-      description: If set uses this file (including path) as Jolokia JVM agent properties (as described in Jolokia's link:https://www.jolokia.org/reference/html/agents.html#agents-jvm[reference manual]). If not set, the `/opt/jolokia/etc/jolokia.properties` will be created using the settings as defined in the manual. Otherwise the rest of the settings in this document are ignored.
-      example: "/opt/jolokia/custom.properties"
-    - name: AB_JOLOKIA_HOST
-      description: Host address to bind to. Defaults to **0.0.0.0**.
-      example: "127.0.0.1"
-    - name: AB_JOLOKIA_PORT
-      description: Port to listen to. Defaults to **8778**.
-      example: "5432"
-    - name: AB_JOLOKIA_USER
-      description: User for basic authentication. Defaults to **jolokia**.
-      example: "myusername"
-    - name: AB_JOLOKIA_PASSWORD
-      description: Password for basic authentication. By default authentication is switched off.
-      example: "mypassword"
-    - name: AB_JOLOKIA_PASSWORD_RANDOM
-      description: Determines if a random AB_JOLOKIA_PASSWORD be generated. Set to **true** to generate random password. Generated value will be written to `/opt/jolokia/etc/jolokia.pw`.
-      example: "true"
-    - name: AB_JOLOKIA_HTTPS
-      description: Switch on secure communication with https. By default self signed server certificates are generated if no `serverCert` configuration is given in **AB_JOLOKIA_OPTS**.
-      example: "true"
-    - name: AB_JOLOKIA_ID
-      description: Agent ID to use (`$HOSTNAME` by default, which is the container id).
-      example: "openjdk-app-1-xqlsj"
-    - name: AB_JOLOKIA_DISCOVERY_ENABLED
-      description: Enable Jolokia discovery. Defaults to **false**.
-      example: "true"
-    - name: AB_JOLOKIA_OPTS
-      description: Additional options to be appended to the agent configuration. They should be given in the format `key=value,key=value,...`.
-      example: "backlog=20"
-    - name: AB_JOLOKIA_AUTH_OPENSHIFT
-      description: Switch on client authentication for OpenShift TLS communication. The value of this parameter can be a relative distinguished name which must be contained in a presented client's certificate. Enabling this parameter will automatically switch Jolokia into https communication mode. The default CA cert is set to `/var/run/secrets/kubernetes.io/serviceaccount/ca.crt`.
-      example: "true"
+    - name: AMQ_TRANSPORT_ENABLED_PROTOCOLS
+      example: TLSv1,TLSv1.1,TLSv1.2
+      description: "Sets the enabled SSL protocols"
+    - name: AMQ_NEED_CLIENT_AUTH
+      example: false
+      description: "Sets SSL to require client authentication"
     - name: SCRIPT_DEBUG
       description: If set to true, ensurses that the bash scripts are executed with the -x option, printing the commands and their arguments as they are executed.
       example: "true"
-    - name: JAVA_MAX_MEM_RATIO
-      description: This is used to calculate a default maximal heap memory based on a containers restriction. If used in a Docker container without any memory constraints for the container then this option has no effect. If there is a memory constraint then `-Xmx` is set to a ratio of the container available memory as set here. The default is `50` which means 50% of the available memory is used as an upper boundary. You can skip this mechanism by setting this value to `0` in which case no `-Xmx` option
-            is added.
-      example: "50"
-    - name: JAVA_INITIAL_MEM_RATIO
-      description: This is used to calculate a default initial heap memory based the maximumal heap memory.  The default is `100` which means 100% of the maximal heap is used for the initial heap size.  You can skip this mechanism by setting this value to `0` in which case no `-Xms` option is added.
-      example: "100"
-    - name: JAVA_MAX_INITIAL_MEM
-      description: The maximum size of the initial heap memory, if the calculated default initial heap is larger then it will be capped at this value.  The default is 4096 MB.
-      example: "4096"
-    - name: JAVA_CORE_LIMIT
-      description: Core limit as described in https://www.kernel.org/doc/Documentation/scheduler/sched-bwc.txt.  Used to configure the number of GC threads and parallelism for ForkJoinPool.  Defaults to container core limit.
-      example: "2"
-    - name: JAVA_DIAGNOSTICS
-      description: Set this to get some diagnostics information to standard output when things are happening. **Disabled by default.**
-      example: "true"
-    - name: GC_MIN_HEAP_FREE_RATIO
-      description: Minimum percentage of heap free after GC to avoid expansion.
-      example: "20"
-    - name: GC_MAX_HEAP_FREE_RATIO
-      description: Maximum percentage of heap free after GC to avoid shrinking.
-      example: "40"
-    - name: GC_TIME_RATIO
-      description: Specifies the ratio of the time spent outside the garbage collection (for example, the time spent for application execution) to the time spent in the garbage collection.
-      example: "4"
-    - name: GC_ADAPTIVE_SIZE_POLICY_WEIGHT
-      description: The weighting given to the current GC time versus previous GC times.
-      example: "90"
-    - name: GC_MAX_METASPACE_SIZE
-      description: The maximum metaspace size.
-      example: "100"
-    - name: "CONTAINER_HEAP_PERCENT"
-      example: 0.5
-      description: Deprecated.  See JAVA_MAX_MEM_RATIO.
-    - name: "INITIAL_HEAP_PERCENT"
-      example: 0.5
-      description: Deprecated.  See JAVA_INITIAL_MEM_RATIO.
 ports:
-    - value: 8778
     - value: 5672
+    - value: 5671
     - value: 1883
+    - value: 8883
     - value: 61613
+    - value: 61612
     - value: 61616
+    - value: 61617
 modules:
       repositories:
           - name: cct_module
             git:
                   url: https://github.com/jboss-openshift/cct_module.git
-                  ref: sprint-21
+                  ref: master
       install:
           - name: dynamic-resources
           - name: s2i-common
@@ -133,18 +74,8 @@
           - name: os-amq-s2i
           - name: os-amq-permissions
           - name: openshift-passwd
-packages:
-      repositories:
-          - jboss-os
-          - jboss-ocp
-          - jboss-rhscl
-      install:
-          - PyYAML
-artifacts:
-    - url: https://maven.repository.redhat.com/ga/org/jolokia/jolokia-jvm/1.3.6.redhat-1/jolokia-jvm-1.3.6.redhat-1-agent.jar
-      md5: 75e5b5ba0b804cd9def9f20a70af649f
-    - path: ce-amq-drain-1.0.0.Final-redhat-1.jar
-      md5: 65b9aba8e5a0b7d7b259a6028f85595e
+          - name: os-logging
+
 run:
       user: 185
       cmd: