On branch 7.3.x
Your branch is behind 'origin/7.3.x' by 2 commits, and can be fast-forwarded.
  (use "git pull" to update your local branch)

Changes to be committed:
  (use "git restore --staged <file>..." to unstage)
	deleted:    src/main/resources/META-INF/persistence.xml
	deleted:    src/main/resources/import.sql
	modified:   src/main/webapp/WEB-INF/jboss-web.xml
	modified:   src/main/webapp/WEB-INF/web.xml
	new file:   src/main/webapp/html/login.html

Untracked files:
  (use "git add <file>..." to include in what will be committed)
	quick.patch
	../websocket-endpoint/src/main/webapp/WEB-INF/undertow-handlers.conf

diff --git a/servlet-security/src/main/resources/META-INF/persistence.xml b/servlet-security/src/main/resources/META-INF/persistence.xml
deleted file mode 100644
index c7408e65d..000000000
--- a/servlet-security/src/main/resources/META-INF/persistence.xml
+++ /dev/null
@@ -1,35 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<!--
-    JBoss, Home of Professional Open Source
-    Copyright 2015, Red Hat, Inc. and/or its affiliates, and individual
-    contributors by the @authors tag. See the copyright.txt in the
-    distribution for a full listing of individual contributors.
-
-    Licensed under the Apache License, Version 2.0 (the "License");
-    you may not use this file except in compliance with the License.
-    You may obtain a copy of the License at
-    http://www.apache.org/licenses/LICENSE-2.0
-    Unless required by applicable law or agreed to in writing, software
-    distributed under the License is distributed on an "AS IS" BASIS,
-    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-    See the License for the specific language governing permissions and
-    limitations under the License.
--->
-<persistence version="2.1"
-    xmlns="http://xmlns.jcp.org/xml/ns/persistence" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
-    xsi:schemaLocation="
-        http://xmlns.jcp.org/xml/ns/persistence
-        http://xmlns.jcp.org/xml/ns/persistence/persistence_2_1.xsd">
-    <persistence-unit name="primary">
-        <!-- If you are running in a production environment, add a managed
-            data source, this example data source is just for development and testing! -->
-        <!-- The datasource is deployed as WEB-INF/servlet-security-quickstart-ds.xml,
-            you can find it in the source at src/main/webapp/WEB-INF/servlet-security-quickstart-ds.xml -->
-        <jta-data-source>java:jboss/datasources/ServletSecurityDS</jta-data-source>
-        <properties>
-            <!-- Properties for Hibernate -->
-            <property name="hibernate.hbm2ddl.auto" value="create-drop" />
-            <property name="hibernate.show_sql" value="false" />
-        </properties>
-    </persistence-unit>
-</persistence>
diff --git a/servlet-security/src/main/resources/import.sql b/servlet-security/src/main/resources/import.sql
deleted file mode 100644
index 815550dc7..000000000
--- a/servlet-security/src/main/resources/import.sql
+++ /dev/null
@@ -1,29 +0,0 @@
---
--- JBoss, Home of Professional Open Source
--- Copyright 2015, Red Hat, Inc. and/or its affiliates, and individual
--- contributors by the @authors tag. See the copyright.txt in the
--- distribution for a full listing of individual contributors.
---
--- Licensed under the Apache License, Version 2.0 (the "License");
--- you may not use this file except in compliance with the License.
--- You may obtain a copy of the License at
--- http://www.apache.org/licenses/LICENSE-2.0
--- Unless required by applicable law or agreed to in writing, software
--- distributed under the License is distributed on an "AS IS" BASIS,
--- WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
--- See the License for the specific language governing permissions and
--- limitations under the License.
---
-
-CREATE TABLE USERS (ID INT, USERNAME VARCHAR(20), PASSWORD VARCHAR(20));
-CREATE TABLE ROLES (ID INT, NAME VARCHAR(20));
-CREATE TABLE USERS_ROLES (USER_ID INT, ROLE_ID INT);
-
-INSERT INTO USERS (ID, USERNAME, PASSWORD) VALUES (1, 'quickstartUser', 'quickstartPwd1!'); 
-INSERT INTO USERS (ID, USERNAME, PASSWORD) VALUES (2, 'guest', 'guestPwd1!');
-
-INSERT INTO ROLES (ID, NAME) VALUES (1, 'quickstarts');
-INSERT INTO ROLES (ID, NAME) VALUES (2, 'guest');
-
-INSERT INTO USERS_ROLES (USER_ID, ROLE_ID) VALUES (1,1);
-INSERT INTO USERS_ROLES (USER_ID, ROLE_ID) VALUES (2,2);
diff --git a/servlet-security/src/main/webapp/WEB-INF/jboss-web.xml b/servlet-security/src/main/webapp/WEB-INF/jboss-web.xml
index 8b52eaf9d..02ab1ce8d 100644
--- a/servlet-security/src/main/webapp/WEB-INF/jboss-web.xml
+++ b/servlet-security/src/main/webapp/WEB-INF/jboss-web.xml
@@ -20,7 +20,7 @@
     xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
     xsi:schemaLocation="http://www.jboss.org/schema/jbossas
     http://www.jboss.org/schema/jbossas/jboss-web_7_2.xsd">
-   <!-- Configure usage of the security domain "other" -->
-   <security-domain>servlet-security-quickstart</security-domain>
+   <!-- Configure usage of the security domain "other" --> 
+   <security-domain>application-security</security-domain>
    <disable-audit>true</disable-audit>
 </jboss-web>
diff --git a/servlet-security/src/main/webapp/WEB-INF/web.xml b/servlet-security/src/main/webapp/WEB-INF/web.xml
index 0aa0d4903..abd3d34f7 100644
--- a/servlet-security/src/main/webapp/WEB-INF/web.xml
+++ b/servlet-security/src/main/webapp/WEB-INF/web.xml
@@ -18,10 +18,26 @@
 <web-app version="3.1" xmlns="http://xmlns.jcp.org/xml/ns/javaee" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xsi:schemaLocation="http://xmlns.jcp.org/xml/ns/javaee http://xmlns.jcp.org/xml/ns/javaee/web-app_3_1.xsd">
 
-   <!-- Configure login to be HTTP Basic -->
-   <login-config>
-      <auth-method>BASIC</auth-method>
-      <realm-name>RealmUsersRoles</realm-name>
-   </login-config>
+   <security-constraint>
+  <web-resource-collection>
+    <web-resource-name>authenticated users</web-resource-name>
+    <url-pattern>/*</url-pattern>
+  </web-resource-collection>
+  <auth-constraint>
+    <role-name>roletest</role-name>
+  </auth-constraint>
+</security-constraint>
+
+<login-config>
+  <auth-method>FORM</auth-method>
+  <realm-name>application-security</realm-name>
+  <form-login-config>
+    <form-login-page>/html/login.html</form-login-page>
+  </form-login-config>
+</login-config>
+
+<welcome-file-list>
+    <welcome-file>index</welcome-file>
+</welcome-file-list>
 </web-app>
 
diff --git a/servlet-security/src/main/webapp/html/login.html b/servlet-security/src/main/webapp/html/login.html
new file mode 100644
index 000000000..df34c3c98
--- /dev/null
+++ b/servlet-security/src/main/webapp/html/login.html
@@ -0,0 +1,28 @@
+<!--
+    JBoss, Home of Professional Open Source
+    Copyright 2015, Red Hat, Inc. and/or its affiliates, and individual
+    contributors by the @authors tag. See the copyright.txt in the
+    distribution for a full listing of individual contributors.
+
+    Licensed under the Apache License, Version 2.0 (the "License");
+    you may not use this file except in compliance with the License.
+    You may obtain a copy of the License at
+    http://www.apache.org/licenses/LICENSE-2.0
+    Unless required by applicable law or agreed to in writing, software
+    distributed under the License is distributed on an "AS IS" BASIS,
+    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+    See the License for the specific language governing permissions and
+    limitations under the License.
+-->
+<!-- Plain HTML page that kicks us into the app -->
+
+<html>
+<head>
+<meta http-equiv="Refresh" content="0; URL=SecuredServlet">
+<form action="j_security_check" method="post">
+  <input type="text" placeholder="Username" name="j_username">
+  <input type="password" placeholder="Password" name="j_password">
+  <input type="submit">
+</form>
+</head>
+</html>